#include <bits/stdc++.h>

using namespace std;

#define int long long
#define pb emplace_back
#define m_p make_pair

const int INF = 1e9;

void solve () {
    int n,m,k;
    cin >> n >> m >> k;
    vector < vector <int> > g(n + 1);
    for (int _ = 0;_ < m;_++) {
        int u,v;
        cin >> u >> v;
        g[u].pb(v);
        g[v].pb(u);
    }
    vector <int> dist(n + 1,-INF);
    set < pair <int,int>, greater < pair <int,int> > > q;
    for (int _ = 0;_ < k;_++) {
        int p,h;
        cin >> p >> h;
        dist[p] = h;
        q.insert(m_p(h,p));
    }
    while (!q.empty()) {
        auto [d,v] = *q.begin();
        q.erase(q.begin());
        for (auto u: g[v]) {
            if (dist[u] < d - 1) {
                q.erase(m_p(dist[u],u));
                dist[u] = d - 1;
                q.insert(m_p(dist[u],u));
            }
        }
    }
    vector <int> ans;
    for (int i = 1;i <= n;i++) {
        if (dist[i] >= 0) {
            ans.pb(i);
        }
    }
    cout << ans.size() << endl;
    for (auto x: ans) {
        cout << x << " ";
    }
}
signed main() {
    solve();

    return 0;
}